package com.example.zxx_im.shoot;

import android.app.Activity;
import android.app.Dialog;
import android.content.DialogInterface;
import android.view.KeyEvent;
import android.widget.Toast;

import androidx.appcompat.app.AlertDialog;

import com.tbruyelle.rxpermissions2.RxPermissions;

import io.reactivex.disposables.Disposable;
import io.reactivex.functions.Consumer;

public class PermissionsUtil {

    private static PermissionsCallBack permission;

    public interface PermissionsCallBack {
        void permissionCallBack();
    }

    public static void rxRequestPermissions(final Activity context, String describe, PermissionsCallBack permissionsCallBack, String... permissions) {

        permission = permissionsCallBack;

        DialogInterface.OnKeyListener onKeyListener = new DialogInterface.OnKeyListener() {
            @Override
            public boolean onKey(DialogInterface dialog, int keyCode, KeyEvent event) {
                return keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0;
            }
        };

        final Dialog alertDialog = new AlertDialog.Builder(context)
                .setTitle("权限申请")
                .setMessage(describe + "为必选项，开通后方可正常使用APP,请在设置中开启。")
                .setOnKeyListener(onKeyListener)
                .setCancelable(false)
                .setPositiveButton("去开启", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.cancel();
                    }
                })
                .setNegativeButton("结束", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        Toast.makeText(context, "${describe}权限未开启，不能使用该功能！", Toast.LENGTH_SHORT).show();
                        dialog.cancel();
                    }
                }).create();

        Disposable subscribe = new RxPermissions(context).request(permissions).subscribe(new Consumer<Boolean>() {

            @Override
            public void accept(Boolean granted) throws Exception {
                if (granted) {
                    if (permission != null)
                        permission.permissionCallBack();
                } else {
                    alertDialog.show();
                }
            }
        });

    }
}
